]> arthur.barton.de Git - bup.git/blob - t/test.sh
Add "set -eo pipefail" to "exclude" and "exclude-from" tests.
[bup.git] / t / test.sh
1 #!/usr/bin/env bash
2 . wvtest.sh
3 . t/lib.sh
4
5 #set -e
6
7 TOP="$(/bin/pwd)"
8 export BUP_DIR="$TOP/buptest.tmp"
9
10 bup()
11 {
12     "$TOP/bup" "$@"
13 }
14
15 WVSTART "init"
16
17 #set -x
18 test -d "$BUP_DIR" && rm -r "$BUP_DIR"
19 WVPASS bup init
20
21 WVSTART "index"
22 D=bupdata.tmp
23 force-delete $D
24 mkdir $D
25 WVFAIL bup index --exclude-from $D/cannot-exist $D
26 WVPASSEQ "$(bup index --check -p)" ""
27 WVPASSEQ "$(bup index --check -p $D)" ""
28 WVFAIL [ -e $D.fake ]
29 WVFAIL bup index --check -u $D.fake
30 WVPASS bup index --check -u $D
31 WVPASSEQ "$(bup index --check -p $D)" "$D/"
32 touch $D/a
33 WVPASS bup random 128k >$D/b
34 mkdir $D/d $D/d/e
35 WVPASS bup random 512 >$D/f
36 WVPASS ln -s non-existent-file $D/g
37 WVPASSEQ "$(bup index -s $D/)" "A $D/"
38 WVPASSEQ "$(bup index -s $D/b)" ""
39 WVPASSEQ "$(bup index --check -us $D/b)" "A $D/b"
40 WVPASSEQ "$(bup index --check -us $D/b $D/d)" \
41 "A $D/d/e/
42 A $D/d/
43 A $D/b"
44 touch $D/d/z
45 bup tick
46 WVPASSEQ "$(bup index --check -usx $D)" \
47 "A $D/g
48 A $D/f
49 A $D/d/z
50 A $D/d/e/
51 A $D/d/
52 A $D/b
53 A $D/a
54 A $D/"
55 WVPASSEQ "$(bup index --check -us $D/a $D/b --fake-valid)" \
56 "  $D/b
57   $D/a"
58 WVPASSEQ "$(bup index --check -us $D/a)" "  $D/a"  # stays unmodified
59 WVPASSEQ "$(bup index --check -us $D/d --fake-valid)" \
60 "  $D/d/z
61   $D/d/e/
62   $D/d/"
63 touch $D/d/z
64 WVPASS bup index -u $D/d/z  # becomes modified
65 WVPASSEQ "$(bup index -s $D/a $D $D/b)" \
66 "A $D/g
67 A $D/f
68 M $D/d/z
69   $D/d/e/
70 M $D/d/
71   $D/b
72   $D/a
73 A $D/"
74
75 WVPASS bup index -u $D/d/e $D/a --fake-invalid
76 WVPASSEQ "$(cd $D && bup index -m .)" \
77 "./g
78 ./f
79 ./d/z
80 ./d/e/
81 ./d/
82 ./a
83 ./"
84 WVPASSEQ "$(cd $D && bup index -m)" \
85 "g
86 f
87 d/z
88 d/e/
89 d/
90 a
91 ./"
92 WVPASSEQ "$(cd $D && bup index -s .)" "$(cd $D && bup index -s .)"
93
94 WVFAIL bup save -t $D/doesnt-exist-filename
95
96 mv $BUP_DIR/bupindex $BUP_DIR/bi.old
97 WVFAIL bup save -t $D/d/e/fifotest
98 mkfifo $D/d/e/fifotest
99 WVPASS bup index -u $D/d/e/fifotest
100 WVPASS bup save -t $D/d/e/fifotest
101 WVPASS bup save -t $D/d/e
102 rm -f $D/d/e/fifotest
103 WVPASS bup index -u $D/d/e
104 WVFAIL bup save -t $D/d/e/fifotest
105 mv $BUP_DIR/bi.old $BUP_DIR/bupindex
106
107 WVPASS bup index -u $D/d/e
108 WVPASS bup save -t $D/d/e
109 WVPASSEQ "$(cd $D && bup index -m)" \
110 "g
111 f
112 d/z
113 d/
114 a
115 ./"
116 WVPASS bup save -t $D/d
117 WVPASS bup index --fake-invalid $D/d/z
118 WVPASS bup save -t $D/d/z
119 WVPASS bup save -t $D/d/z  # test regenerating trees when no files are changed
120 WVPASS bup save -t $D/d
121 WVPASSEQ "$(cd $D && bup index -m)" \
122 "g
123 f
124 a
125 ./"
126 tree1=$(bup save -t $D) || WVFAIL
127 WVPASSEQ "$(cd $D && bup index -m)" ""
128 tree2=$(bup save -t $D) || WVFAIL
129 WVPASSEQ "$tree1" "$tree2"
130 WVPASSEQ "$(bup index -s / | grep ^D)" ""
131 tree3=$(bup save -t /) || WVFAIL
132 WVPASSEQ "$tree1" "$tree3"
133 WVPASS bup save -r :$BUP_DIR -n r-test $D
134 WVFAIL bup save -r :$BUP_DIR/fake/path -n r-test $D
135 WVFAIL bup save -r :$BUP_DIR -n r-test $D/fake/path
136
137 WVSTART "split"
138 echo a >a.tmp
139 echo b >b.tmp
140 WVPASS bup split -b a.tmp >taga.tmp
141 WVPASS bup split -b b.tmp >tagb.tmp
142 cat a.tmp b.tmp | WVPASS bup split -b >tagab.tmp
143 WVPASSEQ $(cat taga.tmp | wc -l) 1
144 WVPASSEQ $(cat tagb.tmp | wc -l) 1
145 WVPASSEQ $(cat tagab.tmp | wc -l) 1
146 WVPASSEQ $(cat tag[ab].tmp | wc -l) 2
147 WVPASSEQ "$(bup split -b a.tmp b.tmp)" "$(cat tagab.tmp)"
148 WVPASSEQ "$(bup split -b --keep-boundaries a.tmp b.tmp)" "$(cat tag[ab].tmp)"
149 WVPASSEQ "$(cat tag[ab].tmp | bup split -b --keep-boundaries --git-ids)" \
150          "$(cat tag[ab].tmp)"
151 WVPASSEQ "$(cat tag[ab].tmp | bup split -b --git-ids)" \
152          "$(cat tagab.tmp)"
153 WVPASS bup split --bench -b <t/testfile1 >tags1.tmp
154 WVPASS bup split -vvvv -b t/testfile2 >tags2.tmp
155 WVPASS bup margin
156 WVPASS bup midx -f
157 WVPASS bup midx --check -a
158 WVPASS bup midx -o $BUP_DIR/objects/pack/test1.midx \
159         $BUP_DIR/objects/pack/*.idx
160 WVPASS bup midx --check -a
161 WVPASS bup midx -o $BUP_DIR/objects/pack/test1.midx \
162         $BUP_DIR/objects/pack/*.idx \
163         $BUP_DIR/objects/pack/*.idx
164 WVPASS bup midx --check -a
165 all=$(echo $BUP_DIR/objects/pack/*.idx $BUP_DIR/objects/pack/*.midx)
166 WVPASS bup midx -o $BUP_DIR/objects/pack/zzz.midx $all
167 bup tick
168 WVPASS bup midx -o $BUP_DIR/objects/pack/yyy.midx $all
169 WVPASS bup midx -a
170 WVPASSEQ "$(echo $BUP_DIR/objects/pack/*.midx)" \
171         "$BUP_DIR/objects/pack/yyy.midx"
172 WVPASS bup margin
173 WVPASS bup split -t t/testfile2 >tags2t.tmp
174 WVPASS bup split -t t/testfile2 --fanout 3 >tags2tf.tmp
175 WVPASS bup split -r "$BUP_DIR" -c t/testfile2 >tags2c.tmp
176 WVPASS bup split -r :$BUP_DIR -c t/testfile2 >tags2c.tmp
177 WVPASS ls -lR \
178    | WVPASS bup split -r :$BUP_DIR -c --fanout 3 --max-pack-objects 3 -n lslr
179 WVPASS bup ls
180 WVFAIL bup ls /does-not-exist
181 WVPASS bup ls /lslr
182 WVPASS bup ls /lslr/latest
183 WVPASS bup ls /lslr/latest/
184 #WVPASS bup ls /lslr/1971-01-01   # all dates always exist
185 WVFAIL diff -u tags1.tmp tags2.tmp
186
187 # fanout must be different from non-fanout
188 WVFAIL diff tags2t.tmp tags2tf.tmp
189 wc -c t/testfile1 t/testfile2
190 wc -l tags1.tmp tags2.tmp
191
192 WVSTART "bloom"
193 WVPASS bup bloom -c $(ls -1 $BUP_DIR/objects/pack/*.idx|head -n1)
194 rm $BUP_DIR/objects/pack/bup.bloom
195 WVPASS bup bloom -k 4
196 WVPASS bup bloom -c $(ls -1 $BUP_DIR/objects/pack/*.idx|head -n1)
197 WVPASS bup bloom -d buptest.tmp/objects/pack --ruin --force
198 WVFAIL bup bloom -c $(ls -1 $BUP_DIR/objects/pack/*.idx|head -n1)
199 WVPASS bup bloom --force -k 5
200 WVPASS bup bloom -c $(ls -1 $BUP_DIR/objects/pack/*.idx|head -n1)
201
202 WVSTART "memtest"
203 WVPASS bup memtest -c1 -n100
204 WVPASS bup memtest -c1 -n100 --existing
205
206 WVSTART "join"
207 WVPASS bup join $(cat tags1.tmp) >out1.tmp
208 WVPASS bup join <tags2.tmp >out2.tmp
209 WVPASS bup join <tags2t.tmp -o out2t.tmp
210 WVPASS bup join -r "$BUP_DIR" <tags2c.tmp >out2c.tmp
211 WVPASS bup join -r ":$BUP_DIR" <tags2c.tmp >out2c.tmp
212 WVPASS diff -u t/testfile1 out1.tmp
213 WVPASS diff -u t/testfile2 out2.tmp
214 WVPASS diff -u t/testfile2 out2t.tmp
215 WVPASS diff -u t/testfile2 out2c.tmp
216
217 WVSTART "save/git-fsck"
218 (
219     set -e
220     cd "$BUP_DIR" || exit 1
221     #git repack -Ad
222     #git prune
223     (cd "$TOP/t/sampledata" && WVPASS bup save -vvn master /) || WVFAIL
224     n=$(git fsck --full --strict 2>&1 | 
225       egrep -v 'dangling (commit|tree|blob)' |
226       tee -a /dev/stderr | 
227       wc -l)
228     WVPASS [ "$n" -eq 0 ]
229 ) || exit 1
230
231 WVSTART "restore"
232 force-delete buprestore.tmp
233 WVFAIL bup restore boink
234 touch $TOP/$D/$D
235 bup index -u $TOP/$D
236 bup save -n master /
237 WVPASS bup restore -C buprestore.tmp "/master/latest/$TOP/$D"
238 WVPASSEQ "$(ls buprestore.tmp)" "bupdata.tmp"
239 force-delete buprestore.tmp
240 WVPASS bup restore -C buprestore.tmp "/master/latest/$TOP/$D/"
241 touch $D/non-existent-file buprestore.tmp/non-existent-file # else diff fails
242 WVPASS diff -ur $D/ buprestore.tmp/
243
244 (
245     tmp=testrestore.tmp
246     force-delete $tmp
247     mkdir $tmp
248     export BUP_DIR="$(pwd)/$tmp/bup"
249     WVPASS bup init
250     mkdir -p $tmp/src/x/y/z
251     WVPASS bup random 8k > $tmp/src/x/y/random-1
252     WVPASS bup random 8k > $tmp/src/x/y/z/random-2
253     WVPASS bup index -u $tmp/src
254     WVPASS bup save --strip -n foo $tmp/src
255
256     WVSTART "restore /foo/latest"
257     WVPASS bup restore -C $tmp/restore /foo/latest
258     WVPASS t/compare-trees $tmp/src/ $tmp/restore/latest/
259
260     WVSTART "restore /foo/latest/"
261     force-delete "$tmp/restore"
262     WVPASS bup restore -C $tmp/restore /foo/latest/
263     for x in $tmp/src/*; do
264         WVPASS t/compare-trees $x/ $tmp/restore/$(basename $x);
265     done
266
267     WVSTART "restore /foo/latest/."
268     force-delete "$tmp/restore"
269     WVPASS bup restore -C $tmp/restore /foo/latest/.
270     WVPASS t/compare-trees $tmp/src/ $tmp/restore/
271
272     WVSTART "restore /foo/latest/x"
273     force-delete "$tmp/restore"
274     WVPASS bup restore -C $tmp/restore /foo/latest/x
275     WVPASS t/compare-trees $tmp/src/x/ $tmp/restore/x/
276
277     WVSTART "restore /foo/latest/x/"
278     force-delete "$tmp/restore"
279     WVPASS bup restore -C $tmp/restore /foo/latest/x/
280     for x in $tmp/src/x/*; do
281         WVPASS t/compare-trees $x/ $tmp/restore/$(basename $x);
282     done
283
284     WVSTART "restore /foo/latest/x/."
285     force-delete "$tmp/restore"
286     WVPASS bup restore -C $tmp/restore /foo/latest/x/.
287     WVPASS t/compare-trees $tmp/src/x/ $tmp/restore/
288 ) || WVFAIL
289
290
291 WVSTART "ftp"
292 WVPASS bup ftp "cat /master/latest/$TOP/$D/b" >$D/b.new
293 WVPASS bup ftp "cat /master/latest/$TOP/$D/f" >$D/f.new
294 WVPASS bup ftp "cat /master/latest/$TOP/$D/f"{,} >$D/f2.new
295 WVPASS bup ftp "cat /master/latest/$TOP/$D/a" >$D/a.new
296 WVPASSEQ "$(sha1sum <$D/b)" "$(sha1sum <$D/b.new)"
297 WVPASSEQ "$(sha1sum <$D/f)" "$(sha1sum <$D/f.new)"
298 WVPASSEQ "$(cat $D/f.new{,} | sha1sum)" "$(sha1sum <$D/f2.new)"
299 WVPASSEQ "$(sha1sum <$D/a)" "$(sha1sum <$D/a.new)"
300
301 WVSTART "tag"
302 WVFAIL bup tag -d v0.n 2>/dev/null
303 WVFAIL bup tag v0.n non-existant 2>/dev/null
304 WVPASSEQ "$(bup tag)" ""
305 WVPASS bup tag v0.1 master
306 WVPASSEQ "$(bup tag)" "v0.1"
307 WVPASS bup tag -d v0.1
308
309 # This section destroys data in the bup repository, so it is done last.
310 WVSTART "fsck"
311 WVPASS bup fsck
312 WVPASS bup fsck --quick
313 if bup fsck --par2-ok; then
314     WVSTART "fsck (par2)"
315 else
316     WVSTART "fsck (PAR2 IS MISSING)"
317 fi
318 WVPASS bup fsck -g
319 WVPASS bup fsck -r
320 WVPASS bup damage $BUP_DIR/objects/pack/*.pack -n10 -s1 -S0
321 WVFAIL bup fsck --quick
322 WVFAIL bup fsck --quick --disable-par2
323 chmod u+w $BUP_DIR/objects/pack/*.idx
324 WVPASS bup damage $BUP_DIR/objects/pack/*.idx -n10 -s1 -S0
325 WVFAIL bup fsck --quick -j4
326 WVPASS bup damage $BUP_DIR/objects/pack/*.pack -n10 -s1024 --percent 0.4 -S0
327 WVFAIL bup fsck --quick
328 WVFAIL bup fsck --quick -rvv -j99   # fails because repairs were needed
329 if bup fsck --par2-ok; then
330     WVPASS bup fsck -r # ok because of repairs from last time
331     WVPASS bup damage $BUP_DIR/objects/pack/*.pack -n202 -s1 --equal -S0
332     WVFAIL bup fsck
333     WVFAIL bup fsck -rvv   # too many errors to be repairable
334     WVFAIL bup fsck -r   # too many errors to be repairable
335 else
336     WVFAIL bup fsck --quick -r # still fails because par2 was missing
337 fi
338
339 WVSTART "exclude-bupdir"
340 D=exclude-bupdir.tmp
341 force-delete $D
342 mkdir $D
343 export BUP_DIR="$D/.bup"
344 WVPASS bup init
345 touch $D/a
346 WVPASS bup random 128k >$D/b
347 mkdir $D/d $D/d/e
348 WVPASS bup random 512 >$D/f
349 WVPASS bup index -ux $D
350 bup save -n exclude-bupdir $D
351 WVPASSEQ "$(bup ls -a exclude-bupdir/latest/$TOP/$D/)" "a
352 b
353 d/
354 f"
355
356 WVSTART "exclude"
357 (
358     set -e -o pipefail
359     D=exclude.tmp
360     force-delete $D
361     mkdir $D
362     export BUP_DIR="$D/.bup"
363     WVPASS bup init
364     touch $D/a
365     WVPASS bup random 128k >$D/b
366     mkdir $D/d $D/d/e
367     WVPASS bup random 512 >$D/f
368     WVPASS bup random 512 >$D/j
369     WVPASS bup index -ux --exclude $D/d --exclude $D/j $D
370     bup save -n exclude $D
371     WVPASSEQ "$(bup ls exclude/latest/$TOP/$D/)" "a
372 b
373 f"
374     mkdir $D/g $D/h
375     WVPASS bup index -ux --exclude $D/d --exclude $TOP/$D/g --exclude $D/h \
376         --exclude $TOP/$D/j $D
377     bup save -n exclude $D
378     WVPASSEQ "$(bup ls exclude/latest/$TOP/$D/)" "a
379 b
380 f"
381 ) || WVFAIL
382
383 WVSTART "exclude-from"
384 (
385     set -e -o pipefail
386     D=exclude-fromdir.tmp
387     EXCLUDE_FILE=exclude-from.tmp
388     echo "$D/d 
389  $TOP/$D/g
390 $D/h
391 $D/i" > $EXCLUDE_FILE
392     force-delete $D
393     mkdir $D
394     export BUP_DIR="$D/.bup"
395     WVPASS bup init
396     touch $D/a
397     WVPASS bup random 128k >$D/b
398     mkdir $D/d $D/d/e
399     WVPASS bup random 512 >$D/f
400     mkdir $D/g $D/h
401     WVPASS bup random 128k > $D/i
402     WVPASS bup index -ux --exclude-from $EXCLUDE_FILE $D
403     bup save -n exclude-from $D
404     WVPASSEQ "$(bup ls exclude-from/latest/$TOP/$D/)" "a
405 b
406 f"
407     rm $EXCLUDE_FILE
408 ) || WVFAIL
409
410 WVSTART "save (no index)"
411 (
412     set -e
413     tmp=save-no-index.tmp
414     force-delete $tmp
415     mkdir $tmp
416     export BUP_DIR="$(pwd)/$tmp/bup"
417     WVPASS bup init
418     WVFAIL bup save -n nothing /
419     rm -r "$tmp"
420 ) || WVFAIL
421
422 WVSTART "save --strip"
423 (
424     tmp=graft-points.tmp
425     force-delete $tmp
426     mkdir $tmp
427     export BUP_DIR="$(pwd)/$tmp/bup"
428     WVPASS bup init
429     mkdir -p $tmp/src/x/y/z
430     WVPASS bup random 8k > $tmp/src/x/y/random-1
431     WVPASS bup random 8k > $tmp/src/x/y/z/random-2
432     WVPASS bup index -u $tmp/src
433     WVPASS bup save --strip -n foo $tmp/src/x/y
434     WVPASS bup restore -C $tmp/restore /foo/latest
435     WVPASS t/compare-trees $tmp/src/x/y/ "$tmp/restore/latest/"
436 ) || WVFAIL
437
438 WVSTART "save --strip-path (relative)"
439 (
440     tmp=graft-points.tmp
441     force-delete $tmp
442     mkdir $tmp
443     export BUP_DIR="$(pwd)/$tmp/bup"
444     WVPASS bup init
445     mkdir -p $tmp/src/x/y/z
446     WVPASS bup random 8k > $tmp/src/x/y/random-1
447     WVPASS bup random 8k > $tmp/src/x/y/z/random-2
448     WVPASS bup index -u $tmp/src
449     WVPASS bup save --strip-path $tmp/src -n foo $tmp/src/x
450     WVPASS bup restore -C $tmp/restore /foo/latest
451     WVPASS t/compare-trees $tmp/src/ "$tmp/restore/latest/"
452 ) || WVFAIL
453
454 WVSTART "save --strip-path (absolute)"
455 (
456     tmp=graft-points.tmp
457     force-delete $tmp
458     mkdir $tmp
459     export BUP_DIR="$(pwd)/$tmp/bup"
460     WVPASS bup init
461     mkdir -p $tmp/src/x/y/z
462     WVPASS bup random 8k > $tmp/src/x/y/random-1
463     WVPASS bup random 8k > $tmp/src/x/y/z/random-2
464     WVPASS bup index -u $tmp/src
465     WVPASS bup save --strip-path "$TOP" -n foo $tmp/src
466     WVPASS bup restore -C $tmp/restore /foo/latest
467     WVPASS t/compare-trees $tmp/src/ "$tmp/restore/latest/$tmp/src/"
468 ) || WVFAIL
469
470 WVSTART "save --strip-path (no match)"
471 (
472     tmp=graft-points.tmp
473     force-delete $tmp
474     mkdir $tmp
475     export BUP_DIR="$(pwd)/$tmp/bup"
476     WVPASS bup init
477     mkdir -p $tmp/src/x/y/z
478     WVPASS bup random 8k > $tmp/src/x/y/random-1
479     WVPASS bup random 8k > $tmp/src/x/y/z/random-2
480     WVPASS bup index -u $tmp/src
481     WVPASS bup save --strip-path $tmp/foo -n foo $tmp/src/x
482     WVPASS bup restore -C $tmp/restore /foo/latest
483     WVPASS t/compare-trees $tmp/src/ "$tmp/restore/latest/$TOP/$tmp/src/"
484 ) || WVFAIL
485
486 WVSTART "save --graft (empty graft points disallowed)"
487 (
488     tmp=graft-points.tmp
489     force-delete $tmp
490     mkdir $tmp
491     export BUP_DIR="$(pwd)/$tmp/bup"
492     WVPASS bup init
493     WVFAIL bup save --graft =/grafted -n graft-point-absolute $tmp
494     WVFAIL bup save --graft $TOP/$tmp= -n graft-point-absolute $tmp
495 ) || WVFAIL
496
497 WVSTART "save --graft /x/y=/a/b (relative paths)"
498 (
499     tmp=graft-points.tmp
500     force-delete $tmp
501     mkdir $tmp
502     export BUP_DIR="$(pwd)/$tmp/bup"
503     WVPASS bup init
504     mkdir -p $tmp/src/x/y/z
505     WVPASS bup random 8k > $tmp/src/x/y/random-1
506     WVPASS bup random 8k > $tmp/src/x/y/z/random-2
507     WVPASS bup index -u $tmp/src
508     WVPASS bup save --graft $tmp/src=x -n foo $tmp/src
509     WVPASS bup restore -C $tmp/restore /foo/latest
510     WVPASS t/compare-trees $tmp/src/ "$tmp/restore/latest/$TOP/x/"
511 ) || WVFAIL
512
513 WVSTART "save --graft /x/y=/a/b (matching structure)"
514 (
515     tmp=graft-points.tmp
516     force-delete $tmp
517     mkdir $tmp
518     export BUP_DIR="$(pwd)/$tmp/bup"
519     WVPASS bup init
520     mkdir -p $tmp/src/x/y/z
521     WVPASS bup random 8k > $tmp/src/x/y/random-1
522     WVPASS bup random 8k > $tmp/src/x/y/z/random-2
523     WVPASS bup index -u $tmp/src
524     WVPASS bup save -v --graft "$TOP/$tmp/src/x/y=$TOP/$tmp/src/a/b" \
525         -n foo $tmp/src/x/y
526     WVPASS bup restore -C $tmp/restore /foo/latest
527     WVPASS t/compare-trees $tmp/src/x/y/ \
528         "$tmp/restore/latest/$TOP/$tmp/src/a/b/"
529 ) || WVFAIL
530
531 WVSTART "save --graft /x/y=/a (shorter target)"
532 (
533     tmp=graft-points.tmp
534     force-delete $tmp
535     mkdir $tmp
536     export BUP_DIR="$(pwd)/$tmp/bup"
537     WVPASS bup init
538     mkdir -p $tmp/src/x/y/z
539     WVPASS bup random 8k > $tmp/src/x/y/random-1
540     WVPASS bup random 8k > $tmp/src/x/y/z/random-2
541     WVPASS bup index -u $tmp/src
542     WVPASS bup save -v --graft "$TOP/$tmp/src/x/y=/a" -n foo $tmp/src/x/y
543     WVPASS bup restore -C $tmp/restore /foo/latest
544     WVPASS t/compare-trees $tmp/src/x/y/ "$tmp/restore/latest/a/"
545 ) || WVFAIL
546
547 WVSTART "save --graft /x=/a/b (longer target)"
548 (
549     tmp=graft-points.tmp
550     export BUP_DIR="$(pwd)/$tmp/bup"
551     force-delete $tmp
552     mkdir $tmp
553     WVPASS bup init
554     mkdir -p $tmp/src/x/y/z
555     WVPASS bup random 8k > $tmp/src/x/y/random-1
556     WVPASS bup random 8k > $tmp/src/x/y/z/random-2
557     WVPASS bup index -u $tmp/src
558     WVPASS bup save -v --graft "$TOP/$tmp/src=$TOP/$tmp/src/a/b/c" \
559         -n foo $tmp/src
560     WVPASS bup restore -C $tmp/restore /foo/latest
561     WVPASS t/compare-trees $tmp/src/ "$tmp/restore/latest/$TOP/$tmp/src/a/b/c/"
562 ) || WVFAIL
563
564 WVSTART "save --graft /x=/ (root target)"
565 (
566     tmp=graft-points.tmp
567     export BUP_DIR="$(pwd)/$tmp/bup"
568     force-delete $tmp
569     mkdir $tmp
570     WVPASS bup init
571     mkdir -p $tmp/src/x/y/z
572     WVPASS bup random 8k > $tmp/src/x/y/random-1
573     WVPASS bup random 8k > $tmp/src/x/y/z/random-2
574     WVPASS bup index -u $tmp/src
575     WVPASS bup save -v --graft "$TOP/$tmp/src/x=/" -n foo $tmp/src/x
576     WVPASS bup restore -C $tmp/restore /foo/latest
577     WVPASS t/compare-trees $tmp/src/x/ "$tmp/restore/latest/"
578 ) || WVFAIL
579
580 #WVSTART "save --graft /=/x/ (root source)"
581 # FIXME: Not tested for now -- will require cleverness, or caution as root.
582
583 WVSTART "indexfile"
584 D=indexfile.tmp
585 INDEXFILE=tmpindexfile.tmp
586 rm -f $INDEXFILE
587 force-delete $D
588 mkdir $D
589 export BUP_DIR="$D/.bup"
590 WVPASS bup init
591 touch $D/a
592 touch $D/b
593 mkdir $D/c
594 WVPASS bup index -ux $D
595 bup save --strip -n bupdir $D
596 WVPASSEQ "$(bup ls bupdir/latest/)" "a
597 b
598 c/"
599 WVPASS bup index -f $INDEXFILE --exclude=$D/c -ux $D
600 bup save --strip -n indexfile -f $INDEXFILE $D
601 WVPASSEQ "$(bup ls indexfile/latest/)" "a
602 b"
603
604
605 WVSTART "import-rsnapshot"
606 D=rsnapshot.tmp
607 export BUP_DIR="$TOP/$D/.bup"
608 force-delete $D
609 mkdir $D
610 WVPASS bup init
611 mkdir -p $D/hourly.0/buptest/a
612 touch $D/hourly.0/buptest/a/b
613 mkdir -p $D/hourly.0/buptest/c/d
614 touch $D/hourly.0/buptest/c/d/e
615 WVPASS true
616 WVPASS bup import-rsnapshot $D/
617 WVPASSEQ "$(bup ls buptest/latest/)" "a/
618 c/"
619
620
621 if [ "$(which rdiff-backup)" != "" ]; then
622     WVSTART "import-rdiff-backup"
623     D=rdiff-backup.tmp
624     export BUP_DIR="$TOP/$D/.bup"
625     force-delete $D
626     mkdir $D
627     WVPASS bup init
628     mkdir $D/rdiff-backup
629     rdiff-backup $TOP/cmd $D/rdiff-backup
630     bup tick
631     rdiff-backup $TOP/Documentation $D/rdiff-backup
632     WVPASS bup import-rdiff-backup $D/rdiff-backup import-rdiff-backup
633     WVPASSEQ "$(bup ls import-rdiff-backup/ | wc -l)" "3"
634     WVPASSEQ "$(bup ls import-rdiff-backup/latest/ | sort)" "$(ls $TOP/Documentation | sort)"
635 fi
636
637
638 WVSTART "compression"
639 D=compression0.tmp
640 export BUP_DIR="$TOP/$D/.bup"
641 force-delete $D
642 mkdir $D
643 WVPASS bup init
644 WVPASS bup index $TOP/Documentation
645 WVPASS bup save -n compression -0 --strip $TOP/Documentation
646 # 'ls' on NetBSD sets -A by default when running as root, so we have to undo
647 # it by grepping out any dotfiles.  (Normal OSes don't auto-set -A, but this
648 # is harmless there.)
649 WVPASSEQ "$(bup ls compression/latest/ | sort)" \
650          "$(ls $TOP/Documentation | grep -v '^\.' | sort)"
651 COMPRESSION_0_SIZE=$(du -k -s $D | cut -f1)
652
653 D=compression9.tmp
654 export BUP_DIR="$TOP/$D/.bup"
655 force-delete $D
656 mkdir $D
657 WVPASS bup init
658 WVPASS bup index $TOP/Documentation
659 WVPASS bup save -n compression -9 --strip $TOP/Documentation
660 WVPASSEQ "$(bup ls compression/latest/ | sort)" "$(ls $TOP/Documentation | sort)"
661 COMPRESSION_9_SIZE=$(du -k -s $D | cut -f1)
662
663 WVPASS [ "$COMPRESSION_9_SIZE" -lt "$COMPRESSION_0_SIZE" ]
664
665
666 WVSTART "save disjoint top-level directories"
667 (
668     set -e
669     top_dir="$(echo $(pwd) | awk -F "/" '{print $2}')"
670     if [ "$top_dir" == tmp ]; then
671         echo "(running from within /tmp; skipping test)"
672         exit 0
673     fi
674     D=bupdata.tmp
675     force-delete $D
676     mkdir -p $D/x
677     date > $D/x/1
678     tmpdir="$(mktemp -d /tmp/bup-test-XXXXXXX)"
679     cleanup() { set -x; rm -r "${tmpdir}"; set +x; }
680     trap cleanup EXIT
681     date > "$tmpdir/2"
682
683     export BUP_DIR="$TOP/buptest.tmp"
684     test -d "$BUP_DIR" && rm -r "$BUP_DIR"
685
686     WVPASS bup init
687     WVPASS bup index -vu $(pwd)/$D/x "$tmpdir"
688     WVPASS bup save -t -n src $(pwd)/$D/x "$tmpdir"
689     # For now, assume that "ls -a" and "sort" use the same order.
690     WVPASSEQ "$(bup ls -a src/latest)" "$(echo -e "$top_dir/\ntmp/" | sort)"
691 ) || WVFAIL
692
693
694 WVSTART "clear-index"
695 D=clear-index.tmp
696 export BUP_DIR="$TOP/$D/.bup"
697 force-delete $TOP/$D
698 mkdir $TOP/$D
699 WVPASS bup init
700 touch $TOP/$D/foo
701 touch $TOP/$D/bar
702 bup index -u $D
703 WVPASSEQ "$(bup index -p)" "$D/foo
704 $D/bar
705 $D/
706 ./"
707 rm $TOP/$D/foo
708 WVPASS bup index --clear
709 bup index -u $TOP/$D
710 WVPASSEQ "$(bup index -p)" "$D/bar
711 $D/
712 ./"